#include <iostream>

using namespace std;

int main()
{
    int n,q;
    cin>>n>>q;
    int p[n];
    long long int d[n],k[q];
    for(int i=0;i<n;i++){
        cin>>d[i]>>p[i];
    }
       for(int i=0;i<q;i++){
        cin>>k[i];
    }
    int i=1,j=0;
long long int stanje=p[0],br=0;
    while(d[0]>k[j]){
     cout<<"0"<<endl;
     j++;
    }

for(long long int dan=d[0];dan<=k[q-1];dan++){
if(i<n){
if(d[i]==dan){

stanje+=p[i];
i++;
}
if(stanje>0){
    stanje--;
    br++;
}
 if(k[j]==dan){
    cout<<br<<endl;
    j++;
 }

}
else{
    while(j<q){
            if(k[j]>stanje){
                br=br+stanje;
             cout<<br<<endl;
             }
            else{
                cout<<k[j]<<endl;
            }
        j++;
    }
    break;
}
}
    return 0;
}